//
//  ViewController.m
//  xmlTest
//
//  Created by Mori Yoshinao on 11/12/22.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController
@synthesize myTextView;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
	[super viewDidLoad];
	
	// 텍스트 뷰를 초기화 시키고 편집불가로 설정
	myTextView.text = @"";
	myTextView.editable = NO;
	
	// URL을 지정해서 XML서버를 작성한다.
	NSURL *myURL = [NSURL URLWithString:@"http://www.ymori.com/itest/test.xml"];
	NSXMLParser *myParser = [[NSXMLParser alloc] initWithContentsOfURL:myURL];
	myParser.delegate = self;
	// 해석을 개시한다.
	[myParser parse];
}

- (void)parserDidStartDocument:(NSXMLParser *)parser {
	// 해석중인 태그를 초기화한다.
	nowTagStr = [NSString stringWithString:@""];
}
- (void)parser:(NSXMLParser *)parser
didStartElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI 
 qualifiedName:(NSString *)qName
	attributes:(NSDictionary *)attributeDict {
	
	// 개시 태그가 "sweets"이면
    if ([elementName isEqualToString:@"sweets"]) {
		// 해석중인 태그로 설정
		nowTagStr = [NSString stringWithString:elementName];
		// 텍스트 버퍼를 초기화시킨다.
		txtBuffer = [NSString stringWithString:@""];
		
		// 텍스트 뷰에 태그 명과 price속성을 추가한다.
		myTextView.text = [myTextView.text stringByAppendingFormat:
                           @"태그 명=[%@]\n 속성 price=[%@]",
                           elementName, [attributeDict objectForKey:@"price"]];
	}
}
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
	// 해석중인 태그가 "sweets"이면
    if ([nowTagStr isEqualToString:@"sweets"]) {
		// 텍스트 버퍼에 문자열을 추가한다.
		txtBuffer = [txtBuffer stringByAppendingString:string];
	}
}
- (void)parser:(NSXMLParser *)parser 
 didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI
 qualifiedName:(NSString *)qName {
	
	// 종료태그가 "sweets"이면
    if ([elementName isEqualToString:@"sweets"]) {
		// 텍스트 뷰에 텍스트 버퍼의 문자열을 추가한다.
		myTextView.text = [myTextView.text stringByAppendingFormat:
                           @"\n 요소=[%@]\n\n",txtBuffer];
	}
}

- (void)viewDidUnload
{
    [self setMyTextView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

@end
